/*

 inputmask --

  Captures what the user typed starting at a certain margc untill the end
  of what they typed.

 If a user types:     =pc 1000 Golden Ferret
	      margv    0   1     2      3    margv
	      margc    1   2     3      4    margc

 then this routine is called:    inputmask(3)

 masked    =                     "Golden Ferret"

 if this routine was called:     inputmask(2)

 masked    =                     "1000 Golden Ferret"

*/

STATIC
void inputmask(char position)
  {
  int loop=position-1;
  int amount=0;

  if (position==0) return;

  //allocate enough memory in masked for the string

  while (loop<margc)
     {
     amount+=strlen(margv[loop])+1;
     loop++;
     }
  //now dynamically allocate memory for the string

  if (ismasked) free(masked);

  masked=alcmem(amount);
  ismasked=1;

  masked[0]='\0';
  if (margc==position) {
     strcpy(masked,margv[position-1]);
     return;
     }//end if margc=position (user specified just one name in userid)
  if (margc>position) {
     while (position <= margc) {
	strcat(masked,margv[position-1]);
	position++;
	if (position <= margc) //if there is another name add a space here
	   strcat(masked," ");
	}//end of while(position < margc)
     }//end if margc>position (user specified more than one name in userid)
 }//end fulluid
